#ifndef _BMPIO_DLL_H_
#define _BMPIO_DLL_H_

#include <windows.h>

#if BUILDING_DLL
# define DLLIMPORT __declspec (dllexport)
#else /* Not BUILDING_DLL */
# define DLLIMPORT __declspec (dllimport)
#endif /* Not BUILDING_DLL */

#define getBmpWidth(bmp) ((bmp)->width)
#define getBmpHeight(bmp) ((bmp)->height)
#define getBmpXY(bmp,x,y) ((bmp)->data[(y)*((bmp)->width)+(x)])

enum {
	BMP_FULL,
	BMP_256,
	BMP_16,
	BMP_MONO
};

enum {
	COLORTABLE_DEFAULT,
	COLORTABLE_AUTODETECT,
	COLORTABLE_INPUT
};

typedef struct {
	unsigned char r;
	unsigned char g;
	unsigned char b;
} rgb_t;

typedef struct {
	int width;
	int height;
	rgb_t* data;
} bmp_t;

#ifdef __cplusplus
extern "C" {
#endif

DLLIMPORT bmp_t* bmpMake(int width,int height);
DLLIMPORT bmp_t* bmpCopy(const bmp_t* source);
DLLIMPORT bmp_t* bmpLoad(const char* filename);
DLLIMPORT int bmpErrorDiffusion(bmp_t* bmp,int type);
DLLIMPORT int bmpSave(const bmp_t* bmp,const char* filename,int type,int cttype,const rgb_t* ct);
DLLIMPORT bmp_t* bmpLoadFromHandle(HDC hDC,HBITMAP hBmp);
DLLIMPORT HBITMAP bmpSaveToHandle(HDC hDC,const bmp_t* bmp);
DLLIMPORT void bmpFree(bmp_t* bmp);

#ifdef __cplusplus
}
#endif

#endif /* _DLL_H_ */
